#include "stdafx.h"



//#define SAFE_CALL(X) if (!X) {_tprintf(_T("error %s\n"), mysql_error(&mysql)); exit(123);}


int succeedCounter=0;
int failureCounter=0;




//_TCHAR* insertStatement=_T("insert into nametable (first_name, last_name) \
//	values(\"nick\", \"huang\")");

//_TCHAR* queryStatement=_T("select * from nametable;");

//_TCHAR* alterStatement=_T("alter table nametable add column image blob");



void displayField(MYSQL_RES* res)
{
	MYSQL_FIELD* field;
	while ((field=mysql_fetch_field(res)))
	{
		_tprintf(_T("field[%s]"), field->name);
	}
}

void displayRow(MYSQL_RES* res)
{
	MYSQL_ROW row;
	int num_fields;
	num_fields = mysql_num_fields(res);
	while ((row=mysql_fetch_row(res)))
	{
		for (int i=0; i<num_fields; i++)
		{
			_tprintf(_T("[%s]"), row[i]);
		}
	}
}



bool connectDB(MYSQL* mysql, char* address)
{
	char* host = address;
	mysql_init(mysql);
	if (address == NULL)
	{
		host = DefaultHost;
	}
	if (!mysql_real_connect(mysql, host, DefaultUser, DefaultPassword,
		DefaultDatabase, DefaultPort, NULL, 0))
	{
		return false;
	}
	return true;
	//SAFE_CALL(mysql_init(mysql));
	//SAFE_CALL(mysql_real_connect(mysql, DefaultHost, DefaultUser, DefaultPassword,
	//	DefaultDatabase, DefaultPort, NULL, 0));
}

void disconnectDB(MYSQL* mysql)
{
	mysql_close(mysql);
}


/*
typedef struct st_mysql_res {
  my_ulonglong row_count;
  MYSQL_FIELD	*fields;
  MYSQL_DATA	*data;
  MYSQL_ROWS	*data_cursor;
  unsigned long *lengths;		/// column lengths of current row/
  MYSQL		*handle;		/ for unbuffered reads /
  MEM_ROOT	field_alloc;
  unsigned int	field_count, current_field;
  MYSQL_ROW	row;			/ If unbuffered read/
  MYSQL_ROW	current_row;		/* buffer to current row /
  my_bool	eof;			/ Used by mysql_fetch_row/
  /* mysql_stmt_close() had to cancel this result /
  my_bool       unbuffered_fetch_cancelled;  
  const struct st_mysql_methods *methods;
} MYSQL_RES;
*/





void freeResult(void* res)
{
	mysql_free_result((MYSQL_RES*)res);
}










/*				
void insertFile(_TCHAR* fullName, _TCHAR* fileName)
{
	DWORD size;
	_TCHAR* namePtr;
	unsigned char digest[16];
	int dataLength, signatureLength, firstLength, nameLength;
	const char* insertFirst="insert into mypicture (picture_time, picture_size, picture_name, picture_signature, picture_data) values (now()";

	const char* insertLast="\")";
	//char* binaryData;
	char* buffer=NULL;
	char* ptr=NULL;

	nameLength=_tcsclen(fileName);
	
	namePtr=fileName+nameLength-3;
	if (!(_tcsicmp(namePtr,  _T("bmp"))==0||
			_tcsicmp(namePtr, _T("jpg"))==0||
			_tcsicmp(namePtr, _T("png"))==0))
	{
		return;						
	}

	if (!mapFile(fullName, ptr, size))
	{
		_ftprintf(stream, _T("fileMapping error %d fullName=%s fileName=%s\n"), GetLastError(),
			fullName, fileName);		
		failureCounter++;
	}
	else
	{
		buffer=new char[size*2+1024];
		if (buffer==NULL)
		{
			_tprintf(_T("alloc mem failed\n"));
			unmapFile(ptr);
			return ;
		}

		calculateMD5((unsigned char*)ptr, size, digest);
		sprintf(buffer, "%s,%d,", insertFirst, size);
		firstLength=strlen(buffer);

		_stprintf((_TCHAR*)(buffer+firstLength), _T("\"%s\",\""), fullName);

		firstLength=strlen(buffer);

		signatureLength=mysql_real_escape_string(&mysql, buffer+firstLength, (const char*)digest, 16);
		
		firstLength+=signatureLength;
		buffer[firstLength]='"';
		firstLength++;
		buffer[firstLength]=',';
		firstLength++;
		buffer[firstLength]='"';
		firstLength++;
		
	
		dataLength=mysql_real_escape_string(&mysql, buffer+firstLength, ptr, size);

	
		memcpy(buffer+dataLength+firstLength, insertLast, strlen(insertLast));

		if (mysql_real_query(&mysql, buffer, dataLength+firstLength+strlen(insertLast)))
		{
			_ftprintf(stream, _T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
				fileName, size);
			_ftprintf(stream, _T("fullName %s \n"), fullName);
			
			//_tprintf(_T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
			//	fileName, size);
			failureCounter++;
		}
		else
		{
			succeedCounter++;
		}
		delete[]buffer;
		unmapFile(ptr);
	}
}
*/

MYSQL mysql;
FILE* stream;

void simpleInsertFile(_TCHAR* fullName, _TCHAR* fileName)
{
	DWORD size;
	_TCHAR* namePtr;
	unsigned char digest[16];
	int dataLength, signatureLength, firstLength, nameLength;
	const char* insertFirst="insert into mymusic (music_time, music_size, music_name, music_signature, music_data) values (now()";

	const char* insertLast="\")";
	//char* binaryData;
	char* buffer=NULL;
	LPBYTE ptr=NULL;

	nameLength=_tcsclen(fileName);
	
	namePtr=fileName+nameLength-3;
	if (!(_tcsicmp(namePtr,  _T("mp3"))==0||
			_tcsicmp(namePtr, _T("mid"))==0||
			_tcsicmp(namePtr, _T("wav"))==0||
			_tcsicmp(namePtr, _T("mpg"))==0||
			_tcsicmp(namePtr, _T("wmv"))==0))
	{
		return;						
	}

	if (!mapFile(fullName, ptr, size))
	{
		_ftprintf(stream, _T("fileMapping error %d fullName=%s fileName=%s\n"), GetLastError(),
			fullName, fileName);		
		failureCounter++;
	}
	else
	{
		buffer=new char[size*2+1024];
		if (buffer==NULL)
		{
			_tprintf(_T("alloc mem failed\n"));
			unmapFile(ptr);
			return ;
		}

		calculateMD5((unsigned char*)ptr, size, digest);
		sprintf(buffer, "%s,%d,", insertFirst, size);
		firstLength=strlen(buffer);

		_stprintf((_TCHAR*)(buffer+firstLength), _T("\"%s\",\""), fullName);

		firstLength=strlen(buffer);

		signatureLength=mysql_real_escape_string(&mysql, buffer+firstLength, (const char*)digest, 16);
		
		firstLength+=signatureLength;
		buffer[firstLength]='"';
		firstLength++;
		buffer[firstLength]=',';
		firstLength++;
		buffer[firstLength]='"';
		firstLength++;
		
	
		dataLength = mysql_real_escape_string(&mysql, buffer+firstLength, (char*)ptr, size);

	
		memcpy(buffer+dataLength+firstLength, insertLast, strlen(insertLast));

		if (mysql_real_query(&mysql, buffer, dataLength+firstLength+strlen(insertLast)))
		{
			_ftprintf(stream, _T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
				fileName, size);
			_ftprintf(stream, _T("fullName %s \n"), fullName);
			
			//_tprintf(_T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
			//	fileName, size);
			failureCounter++;
		}
		else
		{
			succeedCounter++;
		}
		delete[]buffer;
		unmapFile(ptr);
	}
}

void outputFileName(_TCHAR* fullName, _TCHAR* fileName)
{
	_ftprintf(stream, _T("full name %s\n filename %s\n"), fullName, fileName);
}

void addDirectory(TCHAR* dir)
{
	succeedCounter=failureCounter=0;
	//if (mysql_query(&mysql, queryStatement))
	//if (mysql_query(&mysql, insertStatement))
	stream=fopen("result.txt", "w");

	genericFind(dir, simpleInsertFile);
	_ftprintf(stream, _T("succeed=%d, failure=%d\n"), succeedCounter, failureCounter);
	fclose(stream);
	_tprintf(_T("succeed=%d, failure=%d\n"), succeedCounter, failureCounter);
}




